/**
 * Course  Class
 * Author: Dr. Manal Helal
 * Course: CS243 - Object Oriented Programming
 * Date: 29 December 2013
 * Revision 1
 * 
 * Simple File Manager for a small application to manage a school.
 * 
 * */


import java.util.ArrayList;

enum Day {
    SUNDAY, MONDAY, TUESDAY, WEDNESDAY,
    THURSDAY, FRIDAY, SATURDAY 
}

public class Course implements Cloneable, Utilizable {
	private ArrayList <Student> students = new ArrayList<Student>();
	private String code;
	private String name;
	private Lecturer lecturer;
	private Day LectureDay; 
	private int LecturePeriod;
	private String LectureRoom;
	private TA ta;
	private Day LabDay; 
	private int LabPeriod;
	private String LabRoom;
	private School school;
	
	Course (String code, String name, Lecturer l, TA t) {
		this.code = code;
		this.name = name;
		lecturer = l;
		ta = t;
	}
	Course (String code, String name, Lecturer l, TA t, School school) {
		this(code, name, l, t);
		this.school = school;
	}

	Course (String code, String name, Lecturer l, TA t, School school, Day LectureDay, int LecturePeriod, String LectureRoom, Day LabDay, int LabPeriod, String LabRoom) {
		this(code, name, l, t, school);
		this.LectureDay = LectureDay;
		this.LecturePeriod = LecturePeriod;
		this.LectureRoom = LectureRoom;
		this.LabDay = LabDay;
		this.LabPeriod = LabPeriod;
		this.LabRoom = LabRoom;
	
	}

	public void setCode (String c) {
		code = c;
	}
	
	public void setName (String n) {
		name = n;
	}
	
	public void setLecturer (Lecturer l) {
		lecturer = l;
	}
	
	
	public void setTA (TA t) {
		ta = t;
	}
	
	public void setLecureDay (Day LectureDay) {
		this.LectureDay = LectureDay;
	}
	
	public void setLecturePeriod (int LecturePeriod) {
		this.LecturePeriod = LecturePeriod;
	}
	
	public void setLectureRoom (String LectureRoom) {
		this.LectureRoom = LectureRoom;
	}
	
	public void setLabDay (Day LabDay) {
		this.LabDay = LabDay;
	}
	
	public void setLabPeriod (int LabPeriod) {
		this.LabPeriod = LabPeriod;
	}
	
	public void setLabRoom (String LabRoom) {
		this.LabRoom = LabRoom;
	}

	public void setStudents (ArrayList<Student> s) {
		students = s;
	}
	
	public String getCode () {
		return code;
	}
	
	public String getName () {
		return name;
	}
	
	public Lecturer getLecturer () {
		return lecturer;
	}
	
	public TA getTA () {
		return ta;
	}
	
	public Day getLectureDay () {
		return LectureDay;
	}
	
	public int getLecturePeriod () {
		return LecturePeriod;
	}
	
	public String getLectureRoom () {
		return LectureRoom;
	}
	
	public Day getLabDay () {
		return LabDay;
	}
	
	public int getLabPeriod () {
		return LabPeriod;
	}
	
	public String getLabRoom () {
		return LabRoom;
	}

	
	public ArrayList<Student> getStudents () {
		return students;
	}

	public int geLecturetDayInt() {
		switch (LectureDay) {
		case SUNDAY:
			return 0;
		case MONDAY:
			return 1;
		case TUESDAY:
			return 2;
		case WEDNESDAY:
			return 3;
		case THURSDAY:
			return 4;
		case FRIDAY:
			return 5;
		case SATURDAY:
			return 6;
		default:
			return 0;
		}	
	}

	public int geLabtDayInt() {
		switch (LabDay) {
		case SUNDAY:
			return 0;
		case MONDAY:
			return 1;
		case TUESDAY:
			return 2;
		case WEDNESDAY:
			return 3;
		case THURSDAY:
			return 4;
		case FRIDAY:
			return 5;
		case SATURDAY:
			return 6;
		default:
			return 0;
		}	
	}

	public Day getDay(int day) {
		switch (day) {
		case 0:
			return Day.SUNDAY;
		case 1:
			return Day.MONDAY;
		case 2:
			return Day.TUESDAY;
		case 3:
			return Day.WEDNESDAY;
		case 4:
			return Day.THURSDAY;
		case 5:
			return Day.FRIDAY;
		case 6:
			return Day.SATURDAY;
		default:
			return Day.SUNDAY;
		}	
	}
	
	public Day getDay(String day) {
		switch (day) {
		case "SUNDAY":
			return Day.SUNDAY;
		case "MONDAY":
			return Day.MONDAY;
		case "TUESDAY":
			return Day.TUESDAY;
		case "WEDNESDAY":
			return Day.WEDNESDAY;
		case "THURSDAY":
			return Day.THURSDAY;
		case "FRIDAY":
			return Day.FRIDAY;
		case "SATURDAY":
			return Day.SATURDAY;
		default:
			return Day.SUNDAY;
		}	
	}
	
	public void enrollStudent (Student s) {
		students.add(s);
	}

	public boolean withdrawStudent (Student s) {
		if (students.contains(s)) {
			students.remove(s);
			return true;
		}
		return false;
	}
	@Override
	public int weeklyUtilisation() {
		// TODO Auto-generated method stub
		return 0;
	}
	@Override
	public int monthlyUtilisation() {
		// TODO Auto-generated method stub
		return 0;
	}
	@Override
	public int annualUtilisation() {
		// TODO Auto-generated method stub
		return 0;
	}
	
	@Override
	public Course clone () {
		// TODO Auto-generated method stub
		Course c = new Course(this.code, this.name, this.lecturer, this.ta, this.school);
		ArrayList<Student> s = new ArrayList<Student>();
		System.arraycopy(students, 0, s, 0, students.size());
		
		return c;
	}
}
