/**
 * Course GUI Class
 * Author: Dr. Manal Helal
 * Course: CS243 - Object Oriented Programming
 * Date: 29 December 2013
 * Revision 1
 * 
 * Simple File Manager for a small application to manage a school.
 * 
 * */


import java.awt.AWTEvent;
import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import java.awt.GridLayout;

import javax.swing.DefaultComboBoxModel;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JButton;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.ArrayList;
import java.util.Vector;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;


public class CourseGUI extends JFrame {

	private JPanel contentPane;
	private JTextField txtCode;
	private JTextField txtName;
	private JLabel lblLecturer;
	private JComboBox jcmbLect;
	private JLabel lblTA;
	private JComboBox jcmbTA;
	private JLabel lblLectDay;
	private JComboBox jcmbLDay;
	private JLabel lblLPeriod;
	private JComboBox jcmbLPeriod;
	private JLabel lblRoom;
	private JComboBox jcmbLRoom;
	private JLabel lblLabDay;
	private JComboBox jcmbLabDay;
	private JLabel lblLabPeriod;
	private JComboBox jcmbLabPeriod;
	private JLabel lblabRoom;
	private JComboBox jcmbLabRoom;
	private JButton btnAdd;
	private JButton btnUpdate;
	private JButton btnDelete;
	private JButton btnReport;
	private JButton btnNext;
	private JButton btnLast;
	private JButton btnPrev;
	private JButton btnFirst;
	private Course course = new Course (null, null, null, null, null, Day.FRIDAY, 0, null, Day.FRIDAY, 0, null);
	private ArrayList<Course> courseArray = null;
	private ArrayList<Lecturer> lectArray = null;
	private ArrayList<TA> taArray = null;
	private ArrayList<Room> roomArray = null;
	boolean AddingNew;
	int CurrentPosition;

	/**
	 * Create the frame.
	 */
	public CourseGUI() {
		setTitle("Course Management");
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		setBounds(100, 100, 531, 199);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(new GridLayout(7, 4, 0, 0));

		
		lectArray = FM.readLecturer ();
		if (courseArray == null) {	
			JOptionPane.showMessageDialog(null, "You need to define Lecturers before Definind courses. Closing this window.", "Warnning", JOptionPane.WARNING_MESSAGE);
			dispatchEvent(new WindowEvent(this, WindowEvent.WINDOW_CLOSING));
			
		}
		taArray = FM.readTAs ();
		if (taArray == null) {	
			JOptionPane.showMessageDialog(null, "You need to define TAs before Definind courses. Closing this window.", "Warnning", JOptionPane.WARNING_MESSAGE);
			dispatchEvent(new WindowEvent(this, WindowEvent.WINDOW_CLOSING));
			
		}
		roomArray = FM.readRoom ();
		if (roomArray == null) {	
			JOptionPane.showMessageDialog(null, "You need to define rooms before Definind courses. Closing this window.", "Warnning", JOptionPane.WARNING_MESSAGE);
			dispatchEvent(new WindowEvent(this, WindowEvent.WINDOW_CLOSING));
			
		}
		courseArray = FM.readCourses (lectArray, taArray);
		
		if (courseArray == null) {	
			JOptionPane.showMessageDialog(null, "No Course Added to the System.", "Warnning", JOptionPane.WARNING_MESSAGE);
			courseArray = new ArrayList<Course>();
		}
		
		
		addWindowListener(new WindowAdapter() {
			
			@Override
			public void windowClosing(WindowEvent e) {
				String[] data= {"Code", "Name","Lecturer", "TA", "LectureDay", "LecturePeriod", "LectureRoom", "LabDay", "LabPeriod", "LabRoom"}; 
				FM.writeToTabDelimitedFile(data, FM.courseFileName);
				for (int i=0; i<courseArray.size();i++) {
					course = courseArray.get(i);
					data[0] = course.getCode();
					data[1] = course.getName();
					data[2] = course.getLecturer().getLName() + ", " + course.getLecturer().getMI() + ", " + course.getLecturer().getFName();
					data[3] =  course.getTA().getLName() + ", " + course.getTA().getMI() + ", " + course.getTA().getFName();
					data[4] = String.valueOf(course.getLectureDay());
					data[5] = String.valueOf(course.getLecturePeriod());
					data[6] = course.getLectureRoom(); 
					data[7] = String.valueOf(course.getLabDay());
					data[8] = String.valueOf(course.getLabPeriod());
					data[9] = course.getLabRoom(); 
				
					FM.appendToTabDelimitedFile(data, FM.courseFileName);
				}
			}
		});
		
		JLabel lblName = new JLabel("Code");
		contentPane.add(lblName);
		
		txtCode = new JTextField();
		txtCode.setText("Code");
		contentPane.add(txtCode);
		txtCode.setColumns(5);
		
		JLabel lblMi = new JLabel("Name");
		contentPane.add(lblMi);
		
		txtName = new JTextField();
		txtName.setText("Name");
		contentPane.add(txtName);
		txtName.setColumns(10);
		
		lblLecturer = new JLabel("Lecturer");
		contentPane.add(lblLecturer);
		
		Vector<String>  lItems=new Vector<String> ();
		for (int i = 0; i < lectArray.size();i++) 
			lItems.add(lectArray.get(i).getLName() + ", "+ lectArray.get(i).getMI() + ", " + lectArray.get(i).getFName());
	   
		final DefaultComboBoxModel<String> model = new DefaultComboBoxModel<String>(lItems);
		
		jcmbLect = new JComboBox<String> (model);
		
		
		
		
		contentPane.add(jcmbLect);
		
		lblTA = new JLabel("TA");
		contentPane.add(lblTA);

		lItems=new Vector<String> ();
		for (int i = 0; i < taArray.size();i++) 
			lItems.add(taArray.get(i).getLName() + ", "+ taArray.get(i).getMI() + ", " + taArray.get(i).getFName());
	   
		final DefaultComboBoxModel<String> taModel = new DefaultComboBoxModel<String>(lItems);
		
		
		jcmbTA = new JComboBox<String> (taModel);
		contentPane.add(jcmbTA);
		
		
		lblLectDay = new JLabel("Lecture Day");
		contentPane.add(lblLectDay);
		
		jcmbLDay = new JComboBox<String> ();
		lItems=new Vector<String> ();
		lItems.add("Sunday");
		lItems.add("Monday");
		lItems.add("Tuesday");
		lItems.add("Wednesday");
		lItems.add("Thursday");
		lItems.add("Friday");
		lItems.add("Saturday");
		final DefaultComboBoxModel<String> dayModel = new DefaultComboBoxModel<String>(lItems);
		final DefaultComboBoxModel<String> dayLabModel = new DefaultComboBoxModel<String>(lItems);

		jcmbLDay = new  JComboBox<String> (dayModel);
		contentPane.add(jcmbLDay);
		
		
		lItems=new Vector<String> ();
		lItems.add("1");
		lItems.add("2");
		lItems.add("3");
		lItems.add("4");
		lItems.add("5");
		
		final DefaultComboBoxModel<String> perLecModel = new DefaultComboBoxModel<String>(lItems);
		final DefaultComboBoxModel<String> perLabModel = new DefaultComboBoxModel<String>(lItems);

		lItems=new Vector<String> ();
		for (int i = 0; i < roomArray.size();i++) 
			lItems.add(roomArray.get(i).getName());
		final DefaultComboBoxModel<String> roomLecModel = new DefaultComboBoxModel<String>(lItems);
		final DefaultComboBoxModel<String> roomLabModel = new DefaultComboBoxModel<String>(lItems);
		
		
		lblLabDay = new JLabel("Lab Day");
		contentPane.add(lblLabDay);
		
		jcmbLabDay = new JComboBox<String>(dayLabModel);
		
		contentPane.add(jcmbLabDay);
		
		lblLPeriod = new JLabel("Lecture Period");
		contentPane.add(lblLPeriod);
		
				
		jcmbLPeriod = new JComboBox<String> (perLecModel);
				
		contentPane.add(jcmbLPeriod);
		
		lblLabPeriod = new JLabel("Lab Period");
		contentPane.add(lblLabPeriod);
		
		jcmbLabPeriod = new JComboBox<String>(perLabModel);
		
		contentPane.add(jcmbLabPeriod);
		
		
		lblRoom = new JLabel("Lecture Room");
		contentPane.add(lblRoom);

		jcmbLRoom = new JComboBox<String> (roomLecModel);
		
		contentPane.add(jcmbLRoom);
		
		lblabRoom = new JLabel("Lab Room");
		contentPane.add(lblabRoom);
		jcmbLabRoom = new JComboBox<String> (roomLabModel);
		
		contentPane.add(jcmbLabRoom);
	
		if (courseArray != null) {	
			course = courseArray.get(0);
			updateTextFields ();
		}
		
		btnAdd = new JButton("Add");
		btnAdd.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				txtCode.setText("");
				txtName.setText("");
				jcmbLect.setSelectedIndex(-1);
				jcmbTA.setSelectedIndex(-1);
				jcmbLDay.setSelectedIndex(-1);
				jcmbLPeriod.setSelectedIndex(-1);
				jcmbLRoom.setSelectedIndex(-1);
				jcmbLabDay.setSelectedIndex(-1); 
				jcmbLabPeriod.setSelectedIndex(-1);
				jcmbLabRoom.setSelectedIndex(-1);
				AddingNew = true;
			}
		});
		contentPane.add(btnAdd);
		
		btnUpdate = new JButton("Update");
		btnUpdate.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
/*					ta.setFName(txtFirstName.getText());
					ta.setMI(txtMi.getText());
					ta.setLName(txtLastName.getText());
					ta.setPhone(txtPhone.getText());
					ta.setMobile(txtMobile.getText());
					ta.setFax(txtFax.getText());
					ta.setEmail(txtEmail.getText());
					ta.setAddress(txtAddress.getText());
					taArray.add(ta);
*/				
				String[] Names = jcmbLect.getSelectedItem().toString().split(", ");
				if (Names.length < 3)
					return;
				
				Lecturer l = FM.getLecturer(lectArray, Names[2], Names[1], Names[0]);
				
				Names = jcmbTA.getSelectedItem().toString().split(", ");
				if (Names.length < 3)
					return;
				TA t = FM.getTA(taArray, Names[2], Names[1], Names[0]);
				System.out.println("Lec Day Selected Object: " + jcmbLDay.getSelectedItem());
				System.out.println("Lab Day Selected Object: " + jcmbLabDay.getSelectedItem());
				Day lecDay = course.getDay(jcmbLDay.getSelectedIndex());
				Day labDay = course.getDay(jcmbLabDay.getSelectedIndex());
				System.out.println("Lec Day Selected Day: " + lecDay);
				System.out.println("Lab Day Selected Day: " + labDay);
				
				course = new Course(txtCode.getText(), txtName.getText(), l, t, null, lecDay
						,Integer.parseInt(jcmbLPeriod.getSelectedItem().toString()), jcmbLRoom.getSelectedItem().toString(), labDay, 
						Integer.parseInt(jcmbLabPeriod.getSelectedItem().toString()), jcmbLabRoom.getSelectedItem().toString());
				if (AddingNew) {
					courseArray.add(course);
				}
				else if (CurrentPosition >= 0 && CurrentPosition < courseArray.size()) {
					courseArray.remove(CurrentPosition);
					courseArray.add(CurrentPosition, course);
				}
				else 
					JOptionPane.showMessageDialog(null, "No record to update. Press Add button to add new Record.", "Error", JOptionPane.ERROR_MESSAGE);
			}
		});
		contentPane.add(btnUpdate);
		
		btnDelete = new JButton("Delete");
		btnDelete.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				int reply = JOptionPane.showConfirmDialog(null, "Are you sure you want to delete the current Lecturer?");
				if (reply == 0) {
					courseArray.remove(CurrentPosition);
					CurrentPosition --;
					if (CurrentPosition < 0)
						CurrentPosition = 0;
					if (CurrentPosition > courseArray.size())
						CurrentPosition = courseArray.size() -1;
				}
			}
		});
		contentPane.add(btnDelete);
		
		btnReport = new JButton("Report");
		btnReport.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
			}
		});
		contentPane.add(btnReport);
		
		btnFirst = new JButton("<<");
		btnFirst.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				CurrentPosition = 0;
				if (courseArray.size() > CurrentPosition) {
					course = courseArray.get(CurrentPosition);
					updateTextFields ();
				}
				else 
					JOptionPane.showMessageDialog(null, "No record to display. Press Add button to add new Record.", "Information", JOptionPane.INFORMATION_MESSAGE);
			}
		});
		contentPane.add(btnFirst);
		
		btnPrev = new JButton("<");
		btnPrev.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				CurrentPosition --;
				if (CurrentPosition < 0)
					CurrentPosition = 0;
				if (courseArray.size() > CurrentPosition) {
					course = courseArray.get(CurrentPosition);
					updateTextFields ();
				}
				else 
					JOptionPane.showMessageDialog(null, "No record to display. Press Add button to add new Record.", "Information", JOptionPane.INFORMATION_MESSAGE);
			}
		});
		contentPane.add(btnPrev);
		
		btnNext = new JButton(">");
		btnNext.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				CurrentPosition ++;
				if (CurrentPosition >= courseArray.size())
					CurrentPosition = courseArray.size() - 1;
				if (courseArray.size() > CurrentPosition && CurrentPosition>=0) {
					course = courseArray.get(CurrentPosition);
					updateTextFields ();
				}
				else 
					JOptionPane.showMessageDialog(null, "No record to display. Press Add button to add new Record.", "Information", JOptionPane.INFORMATION_MESSAGE);
			}
		});
		contentPane.add(btnNext);
		
		btnLast = new JButton(">>");
		btnLast.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				CurrentPosition = courseArray.size() - 1;
				if (courseArray.size() > CurrentPosition) {
					course = courseArray.get(CurrentPosition);
					updateTextFields ();
				}
				else 
					JOptionPane.showMessageDialog(null, "No record to display. Press Add button to add new Record.", "Information", JOptionPane.INFORMATION_MESSAGE);
			}
		});
		contentPane.add(btnLast);
	}
	
	private void updateTextFields () {
		txtCode.setText(course.getCode());
		txtName.setText(course.getName());
		jcmbLect.setSelectedItem(course.getLecturer().getLName()+", "+course.getLecturer().getMI()+", "+ course.getLecturer().getFName());
		jcmbTA.setSelectedItem(course.getTA().getLName()+", "+course.getTA().getMI()+", "+ course.getTA().getFName());
		jcmbLDay.setSelectedIndex(course.geLecturetDayInt());
		jcmbLPeriod.setSelectedIndex(course.getLecturePeriod());
		jcmbLRoom.setSelectedItem(course.getLectureRoom()); 
		jcmbLabDay.setSelectedItem(course.geLabtDayInt());
		jcmbLabPeriod.setSelectedIndex(course.getLabPeriod());
		jcmbLabRoom.setSelectedItem(course.getLabRoom()); 
	}

}
