/**
 * Lecturer Report GUI Class
 * Author: Dr. Manal Helal
 * Course: CS243 - Object Oriented Programming
 * Date: 29 December 2013
 * Revision 1
 * 
 * Simple File Manager for a small application to manage a school.
 * 
 * */


import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import java.awt.FlowLayout;
import java.util.ArrayList;

import javax.swing.JTextArea;


public class LecturerReport extends JFrame {

	private JPanel contentPane;


	/**
	 * Create the frame.
	 */
	public LecturerReport() {
		setTitle("Lecturer Report");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 450, 300);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(new FlowLayout(FlowLayout.CENTER, 5, 5));
		
		JTextArea txtrLectreport = new JTextArea();
		txtrLectreport.setColumns(35);
		txtrLectreport.setRows(16);
		txtrLectreport.setText("LectReport");
		contentPane.add(txtrLectreport);
		ArrayList<Lecturer> lectArray = FM.readLecturer ();
		ArrayList<TA> taArray = FM.readTAs ();
		ArrayList<Course> courseArray  = FM.readCourses (lectArray, taArray);
		txtrLectreport.setText("Lecturer Report\n\n");
		
		for (int i = 0; i < lectArray.size(); i++) {
			Lecturer l = lectArray.get(i);
			txtrLectreport.append(l.getLName() + ", " + l.getMI() + ", " + l.getLName());
			txtrLectreport.append("\n");
			for (int j = 0; j < courseArray.size(); j++) {
				Course c = courseArray.get(j);
				if (c.getLecturer().getLName().equals(l.getLName()) && c.getLecturer().getMI().equals(l.getMI()) && c.getLecturer().getFName().equals(l.getFName())) {
					txtrLectreport.append(c.getCode() + ": " + c.getName());
					txtrLectreport.append("\n");
				}
			}
		}

	}

}
