/**
 * Room GUI Class
 * Author: Dr. Manal Helal
 * Course: CS243 - Object Oriented Programming
 * Date: 29 December 2013
 * Revision 1
 * 
 * Simple File Manager for a small application to manage a school.
 * 
 * */

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import java.awt.GridLayout;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JButton;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.ArrayList;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;


public class RoomGUI extends JFrame {

	private JPanel contentPane;
	private JLabel lblName;
	private JTextField txtName;
	private JButton btnAdd;
	private JButton btnUpdate;
	private JButton btnDelete;
	private JButton btnReport;
	private JButton btnNext;
	private JButton btnLast;
	private JButton btnPrev;
	private JButton btnFirst;

	private Room room = new Room (null);
	private ArrayList<Room> roomArray ;
	boolean AddingNew;
	int CurrentPosition;

	/**
	 * Create the frame.
	 */
	public RoomGUI() {
		setTitle("Room Management");
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		setBounds(100, 100, 531, 199);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(new GridLayout(5, 2, 0, 0));
		
		lblName = new JLabel("Room Name");
		contentPane.add(lblName);

		txtName = new JTextField();
		txtName.setText("Room Name");
		contentPane.add(txtName);
		txtName.setColumns(10);

		roomArray = FM.readRoom();
		 
		if (roomArray == null) {
			JOptionPane.showMessageDialog(null, "No Room Added to the System.", "Warnning", JOptionPane.WARNING_MESSAGE);
		}
		else {
			room = roomArray.get(0);
			updateTextFields ();
		}
		addWindowListener(new WindowAdapter() {
			
			@Override
			public void windowClosing(WindowEvent e) {
				String[] data= {"Name"}; 
				FM.writeToTabDelimitedFile(data, "db/room.txt");
				for (int i=0; i<roomArray.size();i++) {
					room = roomArray.get(i);
					data[0] = room.getName();
					FM.appendToTabDelimitedFile(data, "db/room.txt");
				}
			}
		});
		
		
		
		btnAdd = new JButton("Add");
		btnAdd.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				txtName.setText("");
				AddingNew = true;
			}
		});
		contentPane.add(btnAdd);
		
		btnUpdate = new JButton("Update");
		btnUpdate.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
/*					lecturer.setFName(txtFirstName.getText());
					lecturer.setMI(txtMi.getText());
					lecturer.setLName(txtLastName.getText());
					lecturer.setPhone(txtPhone.getText());
					lecturer.setMobile(txtMobile.getText());
					lecturer.setFax(txtFax.getText());
					lecturer.setEmail(txtEmail.getText());
					lecturer.setAddress(txtAddress.getText());
					lectArray.add(lecturer);
*/				
				room = new Room(txtName.getText());
				if (AddingNew) {
					roomArray.add(room);
				}
				else if (CurrentPosition >= 0 && CurrentPosition < roomArray.size()) {
					roomArray.remove(CurrentPosition);
					roomArray.add(CurrentPosition, room);
				}
				else 
					JOptionPane.showMessageDialog(null, "No record to update. Press Add button to add new Record.", "Error", JOptionPane.ERROR_MESSAGE);
			}
		});
		contentPane.add(btnUpdate);
		
		btnDelete = new JButton("Delete");
		btnDelete.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				int reply = JOptionPane.showConfirmDialog(null, "Are you sure you want to delete the current Lecturer?");
				if (reply == 0) {
					roomArray.remove(CurrentPosition);
					CurrentPosition --;
					if (CurrentPosition < 0)
						CurrentPosition = 0;
					if (CurrentPosition > roomArray.size())
						CurrentPosition = roomArray.size() -1;
				}
			}
		});
		contentPane.add(btnDelete);
		
		btnReport = new JButton("Report");
		btnReport.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
			}
		});
		contentPane.add(btnReport);
		
		btnFirst = new JButton("<<");
		btnFirst.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				CurrentPosition = 0;
				if (roomArray.size() > CurrentPosition) {
					room = roomArray.get(CurrentPosition);
					updateTextFields ();
				}
				else 
					JOptionPane.showMessageDialog(null, "No record to display. Press Add button to add new Record.", "Information", JOptionPane.INFORMATION_MESSAGE);
			}
		});
		contentPane.add(btnFirst);
		
		btnPrev = new JButton("<");
		btnPrev.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				CurrentPosition --;
				if (CurrentPosition < 0)
					CurrentPosition = 0;
				if (roomArray.size() > CurrentPosition) {
					room = roomArray.get(CurrentPosition);
					updateTextFields ();
				}
				else 
					JOptionPane.showMessageDialog(null, "No record to display. Press Add button to add new Record.", "Information", JOptionPane.INFORMATION_MESSAGE);
			}
		});
		contentPane.add(btnPrev);
		
		btnNext = new JButton(">");
		btnNext.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				CurrentPosition ++;
				if (CurrentPosition >= roomArray.size())
					CurrentPosition = roomArray.size() - 1;
				if (roomArray.size() > CurrentPosition && CurrentPosition>=0) {
					room = roomArray.get(CurrentPosition);
					updateTextFields ();
				}
				else 
					JOptionPane.showMessageDialog(null, "No record to display. Press Add button to add new Record.", "Information", JOptionPane.INFORMATION_MESSAGE);
			}
		});
		contentPane.add(btnNext);
		
		btnLast = new JButton(">>");
		btnLast.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				CurrentPosition = roomArray.size() - 1;
				if (roomArray.size() > CurrentPosition) {
					room = roomArray.get(CurrentPosition);
					updateTextFields ();
				}
				else 
					JOptionPane.showMessageDialog(null, "No record to display. Press Add button to add new Record.", "Information", JOptionPane.INFORMATION_MESSAGE);
			}
		});
		contentPane.add(btnLast);
	}
	
	private void updateTextFields () {
		if (room != null)	
			txtName.setText(room.getName());
	}

}
