/**
 * School Class
 * Author: Dr. Manal Helal
 * Course: CS243 - Object Oriented Programming
 * Date: 29 December 2013
 * Revision 1
 * 
 * Simple File Manager for a small application to manage a school.
 * 
 * */


import java.util.ArrayList;
import java.util.Date;


public class School {
	private String InstitutionName;
	private String Name;
	private String CurrentSemester;
	private Date SemesterStartDate;
	private Date SemesterEndDate;
	private ArrayList<Lecturer> lecturers = new ArrayList<Lecturer>();
	private ArrayList<TA> tas = new ArrayList<TA>();
	private ArrayList<Student> students = new ArrayList<Student>();
	private ArrayList<Course> courses = new ArrayList<Course>();
	
	Lecturer addNewLecturer (String FName, String MI, String LName, String Phone, String Mobile,
			String Fax, String Email, String Address) {
		Lecturer l = new Lecturer (FName, MI, LName, Phone, Mobile, Fax, Email, Address, this);
		lecturers.add(l);
		return l;		
	}
	
	boolean updateLecturer (Lecturer l, String FName, String MI, String LName, String Phone, String Mobile,
			String Fax, String Email, String Address) {
		if (lecturers.contains(l)) {
			lecturers.get(lecturers.indexOf(l)).setFName(FName);
			lecturers.get(lecturers.indexOf(l)).setMI(MI);
			lecturers.get(lecturers.indexOf(l)).setLName(LName);
			lecturers.get(lecturers.indexOf(l)).setPhone(Phone);
			lecturers.get(lecturers.indexOf(l)).setMobile(Mobile);
			lecturers.get(lecturers.indexOf(l)).setFax(Fax);
			lecturers.get(lecturers.indexOf(l)).setEmail(Email);
			lecturers.get(lecturers.indexOf(l)).setAddress(Address);
			return true;
		}
		return false;		
	}
	
	boolean deleteLecturer (Lecturer l) {
		if (lecturers.contains(l)) {
			lecturers.remove(l);
			return true;
		}
		return false;		
	}
	
	TA addNewTA (String FName, String MI, String LName, String Phone, String Mobile,
			String Fax, String Email, String Address) {
		TA t = new TA (FName, MI, LName, Phone, Mobile, Fax, Email, Address, this);
		tas.add(t);
		return t;		
	}
	
	boolean updateTA (TA t, String FName, String MI, String LName, String Phone, String Mobile,
			String Fax, String Email, String Address) {
		if (tas.contains(t)) {
			tas.get(tas.indexOf(t)).setFName(FName);
			tas.get(tas.indexOf(t)).setMI(MI);
			tas.get(tas.indexOf(t)).setLName(LName);
			tas.get(tas.indexOf(t)).setPhone(Phone);
			tas.get(tas.indexOf(t)).setMobile(Mobile);
			tas.get(tas.indexOf(t)).setFax(Fax);
			tas.get(tas.indexOf(t)).setEmail(Email);
			tas.get(tas.indexOf(t)).setAddress(Address);
			return true;
		}
		return false;		
	}
	
	boolean deleteTA (TA t) {
		if (tas.contains(t)) {
			tas.remove(t);
			return true;
		}
		return false;		
	}
	
	Student addNewStudent (String FName, String MI, String LName, String Phone, String Mobile,
			String Fax, String Email, String Address) {
		Student s = new Student (FName, MI, LName, Phone, Mobile, Fax, Email, Address, this);
		students.add(s);
		return s;		
	}
	
	boolean updateStudent (Student s, String FName, String MI, String LName, String Phone, String Mobile,
			String Fax, String Email, String Address) {
		if (students.contains(s)) {
			students.get(students.indexOf(s)).setFName(FName);
			students.get(students.indexOf(s)).setMI(MI);
			students.get(students.indexOf(s)).setLName(LName);
			students.get(students.indexOf(s)).setPhone(Phone);
			students.get(students.indexOf(s)).setMobile(Mobile);
			students.get(students.indexOf(s)).setFax(Fax);
			students.get(students.indexOf(s)).setEmail(Email);
			students.get(students.indexOf(s)).setAddress(Address);
			return true;
		}
		return false;		
	}
	
	boolean deleteStudent (Student s) {
		if (students.contains(s)) {
			students.remove(s);
			return true;
		}
		return false;		
	}
	
	Course addNewCourse (String code, String name, Lecturer l, TA t) {
		Course c = new Course (code, name, l, t, this);
		courses.add(c);
		return c;		
	}
	
	boolean updateCourse (Course c, Lecturer l, TA t) {
		if (courses.contains(c)) {
			courses.get(courses.indexOf(c)).setLecturer(l);
			courses.get(courses.indexOf(c)).setTA(t);
			return true;
		}
		return false;		
	}
	
	boolean deleteCourse (Course c) {
		if (courses.contains(c)) {
			courses.remove(c);
			return true;
		}
		return false;		
	}
}
