/**
 * TA GUI Class
 * Author: Dr. Manal Helal
 * Course: CS243 - Object Oriented Programming
 * Date: 29 December 2013
 * Revision 1
 * 
 * Simple File Manager for a small application to manage a school.
 * 
 * */


import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import java.awt.GridLayout;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JButton;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.ArrayList;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;


public class TAGUI extends JFrame {

	private JPanel contentPane;
	private JTextField txtFirstName;
	private JTextField txtMi;
	private JLabel lblLastName;
	private JTextField txtLastName;
	private JLabel lblPhone;
	private JTextField txtPhone;
	private JLabel lblMobile;
	private JTextField txtMobile;
	private JLabel lblFax;
	private JTextField txtFax;
	private JLabel lblEmail;
	private JTextField txtEmail;
	private JLabel lblAddress;
	private JTextField txtAddress;
	private JButton btnAdd;
	private JButton btnUpdate;
	private JButton btnDelete;
	private JButton btnReport;
	private TA ta = new TA (null, null, null, null, null, null, null, null);
	private ArrayList<TA> taArray;
	boolean AddingNew;
	int CurrentPosition;
	private JButton btnNext;
	private JButton btnLast;
	private JButton btnPrev;
	private JButton btnFirst;

	/**
	 * Create the frame.
	 */
	public TAGUI() {
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowOpened(WindowEvent e) {
				taArray = FM.readTAs();
				 
				if (taArray == null) {
					JOptionPane.showMessageDialog(null, "No TA Added to the System.", "Warnning", JOptionPane.WARNING_MESSAGE);
				}
				else {
					ta = taArray.get(0);
					updateTextFields ();
				}
			}
			@Override
			public void windowClosing(WindowEvent e) {
				String[] data= {"FName", "MI","LName", "Phone", "Mobile", "Fax", "Email", "Address"}; 
				FM.writeToTabDelimitedFile(data, "db/ta.txt");
				for (int i=0; i<taArray.size();i++) {
					ta = taArray.get(i);
					data[0] = ta.getFName();
					data[1] = ta.getMI();
					data[2] = ta.getLName();
					data[3] = ta.getPhone();
					data[4] = ta.getMobile();
					data[5] = ta.getFax();
					data[6] = ta.getEmail(); 
					data[7] = ta.getAddress(); 
				
					FM.appendToTabDelimitedFile(data, "db/ta.txt");
				}
			}
		});
		setTitle("TA Management");
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		setBounds(100, 100, 531, 199);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(new GridLayout(6, 4, 0, 0));
		
		JLabel lblFirstName = new JLabel("First Name");
		contentPane.add(lblFirstName);
		
		txtFirstName = new JTextField();
		txtFirstName.setText("First Name");
		contentPane.add(txtFirstName);
		txtFirstName.setColumns(10);
		
		JLabel lblMi = new JLabel("MI");
		contentPane.add(lblMi);
		
		txtMi = new JTextField();
		txtMi.setText("MI");
		contentPane.add(txtMi);
		txtMi.setColumns(10);
		
		lblLastName = new JLabel("Last Name");
		contentPane.add(lblLastName);
		
		txtLastName = new JTextField();
		txtLastName.setText("Last Name");
		contentPane.add(txtLastName);
		txtLastName.setColumns(10);
		
		lblPhone = new JLabel("Phone");
		contentPane.add(lblPhone);
		
		txtPhone = new JTextField();
		txtPhone.setText("Phone");
		contentPane.add(txtPhone);
		txtPhone.setColumns(10);
		
		lblMobile = new JLabel("Mobile");
		contentPane.add(lblMobile);
		
		txtMobile = new JTextField();
		txtMobile.setText("Mobile");
		contentPane.add(txtMobile);
		txtMobile.setColumns(10);
		
		lblFax = new JLabel("Fax");
		contentPane.add(lblFax);
		
		txtFax = new JTextField();
		txtFax.setText("Fax");
		contentPane.add(txtFax);
		txtFax.setColumns(10);
		
		lblEmail = new JLabel("Email");
		contentPane.add(lblEmail);
		
		txtEmail = new JTextField();
		txtEmail.setText("Email");
		contentPane.add(txtEmail);
		txtEmail.setColumns(10);
		
		lblAddress = new JLabel("Address");
		contentPane.add(lblAddress);
		
		txtAddress = new JTextField();
		txtAddress.setText("Address");
		contentPane.add(txtAddress);
		txtAddress.setColumns(10);
		
		btnAdd = new JButton("Add");
		btnAdd.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				txtFirstName.setText("");
				txtMi.setText("");
				txtLastName.setText("");
				txtPhone.setText("");
				txtMobile.setText("");
				txtFax.setText("");
				txtEmail.setText(""); 
				txtAddress.setText(""); 
				AddingNew = true;
			}
		});
		contentPane.add(btnAdd);
		
		btnUpdate = new JButton("Update");
		btnUpdate.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
/*					ta.setFName(txtFirstName.getText());
					ta.setMI(txtMi.getText());
					ta.setLName(txtLastName.getText());
					ta.setPhone(txtPhone.getText());
					ta.setMobile(txtMobile.getText());
					ta.setFax(txtFax.getText());
					ta.setEmail(txtEmail.getText());
					ta.setAddress(txtAddress.getText());
					taArray.add(ta);
*/				
				ta = new TA(txtFirstName.getText(), txtMi.getText(), txtLastName.getText(), txtPhone.getText(), 
						txtMobile.getText(),txtFax.getText(), txtEmail.getText(), txtAddress.getText());
				if (AddingNew) {
					taArray.add(ta);
				}
				else if (CurrentPosition >= 0 && CurrentPosition < taArray.size()) {
					taArray.remove(CurrentPosition);
					taArray.add(CurrentPosition, ta);
				}
				else 
					JOptionPane.showMessageDialog(null, "No record to update. Press Add button to add new Record.", "Error", JOptionPane.ERROR_MESSAGE);
			}
		});
		contentPane.add(btnUpdate);
		
		btnDelete = new JButton("Delete");
		btnDelete.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				int reply = JOptionPane.showConfirmDialog(null, "Are you sure you want to delete the current Lecturer?");
				if (reply == 0) {
					taArray.remove(CurrentPosition);
					CurrentPosition --;
					if (CurrentPosition < 0)
						CurrentPosition = 0;
					if (CurrentPosition > taArray.size())
						CurrentPosition = taArray.size() -1;
				}
			}
		});
		contentPane.add(btnDelete);
		
		btnReport = new JButton("Report");
		btnReport.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
			}
		});
		contentPane.add(btnReport);
		
		btnFirst = new JButton("<<");
		btnFirst.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				CurrentPosition = 0;
				if (taArray.size() > CurrentPosition) {
					ta = taArray.get(CurrentPosition);
					updateTextFields ();
				}
				else 
					JOptionPane.showMessageDialog(null, "No record to display. Press Add button to add new Record.", "Information", JOptionPane.INFORMATION_MESSAGE);
			}
		});
		contentPane.add(btnFirst);
		
		btnPrev = new JButton("<");
		btnPrev.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				CurrentPosition --;
				if (CurrentPosition < 0)
					CurrentPosition = 0;
				if (taArray.size() > CurrentPosition) {
					ta = taArray.get(CurrentPosition);
					updateTextFields ();
				}
				else 
					JOptionPane.showMessageDialog(null, "No record to display. Press Add button to add new Record.", "Information", JOptionPane.INFORMATION_MESSAGE);
			}
		});
		contentPane.add(btnPrev);
		
		btnNext = new JButton(">");
		btnNext.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				CurrentPosition ++;
				if (CurrentPosition >= taArray.size())
					CurrentPosition = taArray.size() - 1;
				if (taArray.size() > CurrentPosition && CurrentPosition>=0) {
					ta = taArray.get(CurrentPosition);
					updateTextFields ();
				}
				else 
					JOptionPane.showMessageDialog(null, "No record to display. Press Add button to add new Record.", "Information", JOptionPane.INFORMATION_MESSAGE);
			}
		});
		contentPane.add(btnNext);
		
		btnLast = new JButton(">>");
		btnLast.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				CurrentPosition = taArray.size() - 1;
				if (taArray.size() > CurrentPosition) {
					ta = taArray.get(CurrentPosition);
					updateTextFields ();
				}
				else 
					JOptionPane.showMessageDialog(null, "No record to display. Press Add button to add new Record.", "Information", JOptionPane.INFORMATION_MESSAGE);
			}
		});
		contentPane.add(btnLast);
	}
	
	private void updateTextFields () {
		txtFirstName.setText(ta.getFName());
		txtMi.setText(ta.getMI());
		txtLastName.setText(ta.getLName());
		txtPhone.setText(ta.getPhone());
		txtMobile.setText(ta.getMobile());
		txtFax.setText(ta.getFax());
		txtEmail.setText(ta.getEmail()); 
		txtAddress.setText(ta.getAddress()); 
	}

}
